(** File generated by coq-of-ocaml *)
Require Import CoqOfOCaml.CoqOfOCaml.
Require Import CoqOfOCaml.Settings.

Require Import TezosOfOCaml.Proto_alpha.Environment.
Require TezosOfOCaml.Proto_alpha.Constants_storage.
Require TezosOfOCaml.Proto_alpha.Level_repr.
Require TezosOfOCaml.Proto_alpha.Raw_context.
Require TezosOfOCaml.Proto_alpha.Raw_level_repr.
Require TezosOfOCaml.Proto_alpha.Storage.
Require TezosOfOCaml.Proto_alpha.Storage_sigs.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_commitment_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_errors_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_inbox_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_inbox_storage.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_level_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_state_repr.
Require TezosOfOCaml.Proto_alpha.Tx_rollup_state_storage.

Definition just_ctxt {A B C : Set} (function_parameter : A * B * C) : A :=
  let '(ctxt, _, _) := function_parameter in
  ctxt.

Inductive direction : Set :=
| Incr : direction
| Decr : direction.

Definition adjust_unfinalized_commitments_count
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (pkh : Signature.public_key_hash) (dir : direction) : M? Raw_context.t :=
  let delta :=
    match dir with
    | Incr => 1
    | Decr => (-1)
    end in
  let bond_key := (tx_rollup, pkh) in
  let? '(ctxt, commitment) :=
    Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.find)
      ctxt bond_key in
  let count :=
    match commitment with
    | Some count => count +i delta
    | None => delta
    end in
  let? '_ :=
    Error_monad.fail_when (count <i 0)
      (Build_extensible "Commitment_bond_negative" int count) in
  Error_monad.op_gtpipeeqquestion
    (Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.add)
      ctxt bond_key count) just_ctxt.

Definition remove_bond
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (contract : Signature.public_key_hash) : M? Raw_context.t :=
  let bond_key := (tx_rollup, contract) in
  let? '(ctxt, bond) :=
    Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.find)
      ctxt bond_key in
  match bond with
  | None =>
    Error_monad.fail
      (Build_extensible "Bond_does_not_exist" Signature.public_key_hash contract)
  | Some 0 =>
    Error_monad.op_gtpipeeqquestion
      (Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.remove)
        ctxt bond_key) just_ctxt
  | Some _ =>
    Error_monad.fail
      (Build_extensible "Bond_in_use" Signature.public_key_hash contract)
  end.

Definition find
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (level : Tx_rollup_level_repr.t)
  : M?
    (Raw_context.t *
      option
        Tx_rollup_commitment_repr.Submitted_commitment.(Storage_sigs.VALUE.t)) :=
  let? '(ctxt, commitment) :=
    Storage.Tx_rollup.Commitment.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.find)
      ctxt (level, tx_rollup) in
  match commitment with
  | None =>
    let? ctxt := Tx_rollup_state_storage.assert_exist ctxt tx_rollup in
    return? (ctxt, None)
  | Some res => return? (ctxt, (Some res))
  end.

Definition get
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (level : Tx_rollup_level_repr.t)
  : M?
    (Raw_context.t *
      Tx_rollup_commitment_repr.Submitted_commitment.(Storage_sigs.VALUE.t)) :=
  let? '(ctxt, commitment) := find ctxt tx_rollup level in
  match commitment with
  | None =>
    Error_monad.fail
      (Build_extensible "Commitment_does_not_exist" Tx_rollup_level_repr.t level)
  | Some commitment => return? (ctxt, commitment)
  end.

Definition check_commitment_level
  (state_value : Tx_rollup_state_repr.t)
  (commitment : Tx_rollup_commitment_repr.t) : M? unit :=
  let? expected_level := Tx_rollup_state_repr.next_commitment_level state_value
    in
  let? '_ :=
    Error_monad.fail_when
      (Tx_rollup_level_repr.op_lt commitment.(Tx_rollup_commitment_repr.t.level)
        expected_level)
      (Build_extensible "Level_already_has_commitment" Tx_rollup_level_repr.t
        commitment.(Tx_rollup_commitment_repr.t.level)) in
  let? '_ :=
    Error_monad.fail_when
      (Tx_rollup_level_repr.op_lt expected_level
        commitment.(Tx_rollup_commitment_repr.t.level))
      (Build_extensible "Commitment_too_early"
        Tx_rollup_errors_repr.Commitment_too_early
        {|
          Tx_rollup_errors_repr.Commitment_too_early.provided :=
            commitment.(Tx_rollup_commitment_repr.t.level);
          Tx_rollup_errors_repr.Commitment_too_early.expected := expected_level
          |}) in
  Error_monad.return_unit.

(** [check_commitment_predecessor ctxt tx_rollup state commitment]
    will raise an error if the [predecessor] field of [commitment] is
    not consistent with the context, assuming its [level] field is
    correct. *)
Definition check_commitment_predecessor {A : Set}
  (ctxt : A) (state_value : Tx_rollup_state_repr.t)
  (commitment : Tx_rollup_commitment_repr.t) : M? A :=
  match
    ((commitment.(Tx_rollup_commitment_repr.t.predecessor),
      (Tx_rollup_state_repr.next_commitment_predecessor state_value)),
      match
        (commitment.(Tx_rollup_commitment_repr.t.predecessor),
          (Tx_rollup_state_repr.next_commitment_predecessor state_value)) with
      | (Some pred_hash, Some expected_hash) =>
        Tx_rollup_commitment_repr.Commitment_hash.op_eq pred_hash expected_hash
      | _ => false
      end) with
  | ((Some pred_hash, Some expected_hash), true) => return? ctxt
  | ((None, None), _) => return? ctxt
  | ((provided, expected), _) =>
    Error_monad.fail
      (Build_extensible "Wrong_predecessor_hash"
        Tx_rollup_errors_repr.Wrong_predecessor_hash
        {| Tx_rollup_errors_repr.Wrong_predecessor_hash.provided := provided;
          Tx_rollup_errors_repr.Wrong_predecessor_hash.expected := expected |})
  end.

Definition check_commitment_batches_and_inbox_hash
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (commitment : Tx_rollup_commitment_repr.t) : M? Raw_context.t :=
  let?
    '(ctxt, {|
      Tx_rollup_inbox_repr.metadata.inbox_length := inbox_length;
        Tx_rollup_inbox_repr.metadata.hash := hash_value
        |}) :=
    Tx_rollup_inbox_storage.get_metadata ctxt
      commitment.(Tx_rollup_commitment_repr.t.level) tx_rollup in
  let? '_ :=
    Error_monad.fail_unless
      (Compare.List_length_with.op_eq
        commitment.(Tx_rollup_commitment_repr.t.batches)
        (Int32.to_int inbox_length))
      (Build_extensible "Wrong_batch_count" unit tt) in
  let? '_ :=
    Error_monad.fail_unless
      (Tx_rollup_inbox_repr.equal_hash
        commitment.(Tx_rollup_commitment_repr.t.inbox_hash) hash_value)
      (Build_extensible "Wrong_inbox_hash" unit tt) in
  return? ctxt.

Definition add_commitment
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (state_value : Tx_rollup_state_repr.t) (pkh : Signature.public_key_hash)
  (commitment : Tx_rollup_commitment_repr.t)
  : M? (Raw_context.t * Tx_rollup_state_repr.t) :=
  let commitment_limit := Constants_storage.tx_rollup_max_finalized_levels ctxt
    in
  let? '_ :=
    Error_monad.fail_when
      ((Tx_rollup_state_repr.finalized_commitments_count state_value) >=i
      commitment_limit)
      (Build_extensible "Too_many_finalized_commitments" unit tt) in
  let? '_ := check_commitment_level state_value commitment in
  let? ctxt := check_commitment_predecessor ctxt state_value commitment in
  let? ctxt := check_commitment_batches_and_inbox_hash ctxt tx_rollup commitment
    in
  let current_level := (Raw_context.current_level ctxt).(Level_repr.t.level) in
  let commitment_hash := Tx_rollup_commitment_repr.hash_value commitment in
  let submitted :=
    {|
      Tx_rollup_commitment_repr.Submitted_commitment.t.commitment := commitment;
      Tx_rollup_commitment_repr.Submitted_commitment.t.commitment_hash :=
        commitment_hash;
      Tx_rollup_commitment_repr.Submitted_commitment.t.committer := pkh;
      Tx_rollup_commitment_repr.Submitted_commitment.t.submitted_at :=
        current_level;
      Tx_rollup_commitment_repr.Submitted_commitment.t.finalized_at := None |}
    in
  let? '(ctxt, _, _) :=
    Storage.Tx_rollup.Commitment.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.add)
      ctxt (commitment.(Tx_rollup_commitment_repr.t.level), tx_rollup) submitted
    in
  let? state_value :=
    Tx_rollup_state_repr.record_commitment_creation state_value
      commitment.(Tx_rollup_commitment_repr.t.level) commitment_hash in
  let? ctxt := adjust_unfinalized_commitments_count ctxt tx_rollup pkh Incr in
  return? (ctxt, state_value).

Definition pending_bonded_commitments
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (pkh : Signature.public_key_hash) : M? (Raw_context.t * int) :=
  let? '(ctxt, pending) :=
    Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.find)
      ctxt (tx_rollup, pkh) in
  return? (ctxt, (Option.value_value pending 0)).

Definition has_bond
  (ctxt : Raw_context.t) (tx_rollup : Tx_rollup_repr.t)
  (pkh : Signature.public_key_hash) : M? (Raw_context.t * bool) :=
  let? '(ctxt, pending) :=
    Storage.Tx_rollup.Commitment_bond.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.find)
      ctxt (tx_rollup, pkh) in
  return? (ctxt, (Option.is_some pending)).

Definition finalize_commitment
  (ctxt : Raw_context.t) (rollup : Tx_rollup_repr.t)
  (state_value : Tx_rollup_state_repr.t)
  : M? (Raw_context.t * Tx_rollup_state_repr.t * Tx_rollup_level_repr.t) :=
  match
    ((Tx_rollup_state_repr.oldest_inbox_level state_value),
      (Tx_rollup_state_repr.commitment_head_level state_value)) with
  | (Some oldest_inbox_level, Some _) =>
    let? '(ctxt, commitment) := get ctxt rollup oldest_inbox_level in
    let finality_period := Constants_storage.tx_rollup_finality_period ctxt in
    let current_level := (Raw_context.current_level ctxt).(Level_repr.t.level)
      in
    let? '_ :=
      Error_monad.fail_when
        (Raw_level_repr.op_lt current_level
          (Raw_level_repr.add
            commitment.(Tx_rollup_commitment_repr.Submitted_commitment.t.submitted_at)
            finality_period))
        (Build_extensible "No_commitment_to_finalize" unit tt) in
    let? ctxt :=
      adjust_unfinalized_commitments_count ctxt rollup
        commitment.(Tx_rollup_commitment_repr.Submitted_commitment.t.committer)
        Decr in
    let? ctxt := Tx_rollup_inbox_storage.remove ctxt oldest_inbox_level rollup
      in
    let? '(ctxt, _) :=
      Storage.Tx_rollup.Commitment.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.update)
        ctxt (oldest_inbox_level, rollup)
        (Tx_rollup_commitment_repr.Submitted_commitment.t.with_finalized_at
          (Some current_level) commitment) in
    let? state_value :=
      Tx_rollup_state_repr.record_inbox_deletion state_value oldest_inbox_level
      in
    return? (ctxt, state_value, oldest_inbox_level)
  | _ => Error_monad.fail (Build_extensible "No_commitment_to_finalize" unit tt)
  end.

Definition remove_commitment
  (ctxt : Raw_context.t) (rollup : Tx_rollup_repr.t)
  (state_value : Tx_rollup_state_repr.t)
  : M? (Raw_context.t * Tx_rollup_state_repr.t * Tx_rollup_level_repr.t) :=
  match Tx_rollup_state_repr.commitment_tail_level state_value with
  | Some tail =>
    let? '(ctxt, commitment) := get ctxt rollup tail in
    let? '_ :=
      match
        commitment.(Tx_rollup_commitment_repr.Submitted_commitment.t.finalized_at)
        with
      | Some finalized_at =>
        let withdraw_period := Constants_storage.tx_rollup_withdraw_period ctxt
          in
        let current_level :=
          (Raw_context.current_level ctxt).(Level_repr.t.level) in
        Error_monad.fail_when
          (Raw_level_repr.op_lt current_level
            (Raw_level_repr.add finalized_at withdraw_period))
          (Build_extensible "No_commitment_to_remove" unit tt)
      | None =>
        Error_monad.fail
          (Build_extensible "Internal_error" string "Missing finalized_at field")
      end in
    let? '(ctxt, _freed_size, _existed) :=
      Storage.Tx_rollup.Commitment.(Storage_sigs.Non_iterable_indexed_carbonated_data_storage.remove)
        ctxt (tail, rollup) in
    let? state_value :=
      Tx_rollup_state_repr.record_commitment_deletion state_value tail
        commitment.(Tx_rollup_commitment_repr.Submitted_commitment.t.commitment_hash)
      in
    return? (ctxt, state_value, tail)
  | None =>
    Error_monad.fail (Build_extensible "No_commitment_to_remove" unit tt)
  end.

Definition reject_commitment
  (ctxt : Raw_context.t) (rollup : Tx_rollup_repr.t)
  (state_value : Tx_rollup_state_repr.t) (level : Tx_rollup_level_repr.level)
  : M? (Raw_context.t * Tx_rollup_state_repr.t) :=
  match
    ((Tx_rollup_state_repr.oldest_inbox_level state_value),
      (Tx_rollup_state_repr.commitment_head_level state_value)) with
  | (Some inbox_tail, Some commitment_head) =>
    let? '_ :=
      Error_monad.fail_unless
        ((Tx_rollup_level_repr.op_lteq inbox_tail level) &&
        (Tx_rollup_level_repr.op_lteq level commitment_head))
        (Build_extensible "Invalid_rejection_level_argument" unit tt) in
    let? '(ctxt, pred_hash) :=
      match Tx_rollup_level_repr.pred level with
      | Some pred_level =>
        let? '(ctxt, pred_commitment) := find ctxt rollup pred_level in
        let pred_hash :=
          Option.map
            (fun (x_value :
              Tx_rollup_commitment_repr.Submitted_commitment.(Storage_sigs.VALUE.t))
              =>
              Tx_rollup_commitment_repr.hash_value
                x_value.(Tx_rollup_commitment_repr.Submitted_commitment.t.commitment))
            pred_commitment in
        return? (ctxt, pred_hash)
      | None => return? (ctxt, None)
      end in
    let? state_value :=
      Tx_rollup_state_repr.record_commitment_rejection state_value level
        pred_hash in
    return? (ctxt, state_value)
  | _ =>
    Error_monad.fail
      (Build_extensible "Invalid_rejection_level_argument" unit tt)
  end.
